// N88-DiskBASIC t@CovO n88file.exe

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char dir[0x100 * 22];		// Directory (12sector)
static unsigned char fat[0x100];			// FAT (1sector)
static unsigned char buffer[0x100*26*154];	// 256byte x 26sector x 154track
static char dirpath[FILENAME_MAX];			// 쐬fBNg

void usage(int _code)
{
	fprintf(stderr, "Usage: n88file.exe [d88file] [-d][-b][-s[0|1|2]]\n");
	fprintf(stderr, "       -d  : TufBNg쐬Ȃ\n");
	fprintf(stderr, "       -b  : @Bt@Cbsavewb_؂藎Ƃ\n");
	fprintf(stderr, "       -s0 : t@C̃Xy[X폜ďo (default)\n");
	fprintf(stderr, "       -s1 : t@C̃Xy[X̂܂܏o\n");
	fprintf(stderr, "       -s2 : t@C̃Xy[X _ ɒuďo\n");
	exit(_code);
}

int main(int argc, char *argv[])
{
	int mode=1;
	int space=0;
	int bscut=0,bh=0;
	int i;
	D88 disk;
	FILE *fp = NULL;

	fprintf(stderr,"N88-Disk BASIC FILE CUTTER version 0.5\n");

	// R}hC
	if (argc<2) usage(1);
	if (argc>2)
	{
		for (i=2; i<argc; i++)
		{
			if (!strcmp(argv[i],"-?") || !strcmp(argv[i],"-h") ) usage(1);
			if (!strcmp(argv[i],"-d")) mode=0;
			if (!strcmp(argv[i],"-b")) bscut=1;
			if (!strncmp(argv[i],"-s",2))
			{
				if (*(argv[i]+2)>='0' && *(argv[i]+2)<='2')
				{
					space = *(argv[i]+2)-'0';
				}
			}
		}
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W
	int d,media;
	int secnum,trknum,crsnum,dirtrk,dirsec,fatsec,crsmax;

	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		media = disk.GetDiskType();		// fBXNʂ擾
		switch (media)
		{
			case disk.TYPE_2D:
				printf("MEDIA TYPE = 2D\n");
				secnum = 16;	// ZN^/gbN
				trknum = 80;	// gbN/fBXN
				crsnum = 8;		// ZN^/NX^
				dirtrk = 37;	// fBNg̃gbN
				dirsec = 12;	// fBNg̃ZN^
				fatsec = 14;	// FAT̊JnZN^
				break;
			case disk.TYPE_2DD:
				printf("MEDIA TYPE = 2DD\n");
				secnum = 16;
				trknum = 160;
				crsnum = 16;
				dirtrk = 80;
				dirsec = 12;
				fatsec = 14;
				break;
			case disk.TYPE_2HD:
				printf("MEDIA TYPE = 2HD\n");
				secnum = 26;
				trknum = 154;
				crsnum = 26;
				dirtrk = 70;
				dirsec = 22;
				fatsec = 24;
				break;
		}
		disk.SetRecordRange(1,secnum);	// gbÑZN^ݒ
		crsmax = secnum*trknum/crsnum;	// NX^ől

		if (mode)
		{
			sprintf(dirpath,"%03d",d);		// fBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		// fBNgǂݍ
		if (disk.ReadDATA(dirtrk, dirtrk>>1, dirtrk&1, 1, 1, dir, 0x100*dirsec)!=0x100*dirsec) continue;
		// FATǂݍ
		if (disk.ReadDATA(dirtrk, dirtrk>>1, dirtrk&1, fatsec, 1, fat, 0x100)!=0x100) continue;

		// gbNPʂŃfBXNC[WۂƓǂݍ
		for (int trk=0; trk<trknum; trk++)
		{
			disk.ReadDATA(trk, trk>>1, trk&1, 0x01, 0x01, &buffer[0x100*secnum*trk], 0x100*secnum);
		}

		// t@C̐؂o
		for (int fn=0; fn<sizeof(dir)/0x10; fn++)
		{
			unsigned char *ent = &dir[fn*0x10];		// fBNgGg|C^`

			if (ent[0] == 0x00) continue;	// killꂽt@C̓XLbv
			if (ent[0] == 0xff) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];		// t@C

			int fnp=0;
			for (i=0; i<9; i++)
			{
				if (i==6) fname[fnp++] = '.';	// gqKvȂt
				char c=ent[i];			// t@CPo
				if (c==' ' && space==0) continue; 	// Xy[X̍폜
				if (c==' ' && space==2) c='_';		// Xy[X̒u
				if (strchr("?*/\\:<>|",c)) c='#';	// DOSŎgpłȂ̒u
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			bh = 0;
			fp = fopen(fname, "wb");	// o̓t@CI[v
			if (fp == NULL) break;
			printf("%-9s",fname);
			if (bscut && (ent[9]&1==1))
			{
				bh = 4;
				printf(" *** [HEADER CUT]");
			}
			printf("\n");

			int cruster = ent[10];		// JnNX^
			if (cruster>=crsmax)
			{
				printf("** NX^j **\n");
				break;
			}

			while (fat[cruster] < 0xc0)
			{
				fwrite(&buffer[cruster*0x100*crsnum+bh], 1, 0x100*crsnum-bh, fp);	// 1NX^
				bh = 0;
				if (ferror(fp))
				{
					fprintf(stderr, "t@C߂܂.\n");
					return 1;
				}
				cruster = fat[cruster];	// FAT`FCH
				if (cruster>=crsmax)
				{
					printf("** NX^j **\n");
					break;
				}
			}

			fwrite(&buffer[cruster*0x100*crsnum+bh], 1, 0x100*(fat[cruster] & 0x1f)-bh, fp);	// `FC̍Ō
			if (ferror(fp))
			{ 
				fprintf(stderr, "t@C߂܂\n");
				return 1;
			}
			fclose(fp);		// t@CN[Y
			fp = NULL;
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}

